//-----------------------------------------------------------------------------
//@V~[VRPGۂTvQ[
//-----------------------------------------------------------------------------

#ifndef __SAMPLE405__
#define __SAMPLE405__

#include <Windows.h>
#include <mmsystem.h>
#include <d3dx9.h>
#include <dinput.h>

#include <tchar.h>

#include <commctrl.h>
#include <basetsd.h>

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

//-----------------------------------------------------------------------------
//@}N̒`
//-----------------------------------------------------------------------------
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }

//-----------------------------------------------------------------------------
//@萔`Ƃ
//-----------------------------------------------------------------------------
/*----------萔*/
#define kWINDOW_TITLE	"GAME TEST"
#define	kERROR_MSG		"ERROR"

#define	kX_FIELD_FLAT	"field_flat.x"
#define	kX_FIELD_ROCK	"field_rock.x"
#define	kX_FIELD_SAND	"field_sand.x"
#define	kX_FIELD_NOT	"field_not.x"
/**/
#define	kX_SYS_CURSOR	"sys_cursor.x"
#define	kX_SYS_RANGE	"sys_range.x"
#define	kX_SYS_BG		"sys_bg.x"
#define	kX_SYS_MOVED	"sys_moved.x"
/**/
#define	kX_PIECE_BS		"B_Soldier.x"
#define	kX_PIECE_BA		"B_Archer.x"
#define	kX_PIECE_BT		"B_Trooper.x"
#define	kX_PIECE_BC		"B_Castle.x"

#define	kX_PIECE_RS		"R_Soldier.x"
#define	kX_PIECE_RA		"R_Archer.x"
#define	kX_PIECE_RT		"R_Trooper.x"
#define	kX_PIECE_RC		"R_Castle.x"

/*----------l萔*/
/*EBhĚ`Ȃ*/
#define	kWINDOW_WIDTH	800
#define	kWINDOW_HEIGHT	600
#define	kWINDOW_TOP		50
#define	kWINDOW_LEFT	50

/*̍ő咷iSp127j*/
#define	kSTR_LENGTH		255

/*PʎԂ̈ړʐݒ*/
#define	kDIV_UNIT		45
#define	kTIMER			( 1000 / kDIV_UNIT )
#define	kSLEEP			16

/*̒lɓx|ƃWAɂȂ*/
#define	kDEG_TO_RAD		( D3DX_PI * 2.0f / 360.0f)

#define	kPI_3FOURTH		( D3DX_PI * 3.0f / 4.0f )
#define	kPI_1FOURTH		( D3DX_PI / 4.0f )
#define	kPI_HALF		( D3DX_PI / 2.0f )

#define	kMOST_FAR_POINT	100000.0f				//ł_

/*}bv̍LƂ*/
#define	kMAP_MAX_WIDTH	17
#define	kMAP_MAX_LENGTH	17
#define	kMAP_OBJECTS	(kMAP_MAX_WIDTH * kMAP_MAX_LENGTH)

//
#define	kSTEP_ZERO		0
#define	kSTEP_MAXIMUM	99

/*oHTpX^bN[*/
#define	kSTACK_DEPTH	50

/*̐̍ő吔*/
#define	kNUM_OF_PIECE	16

/*_Ƃ*/
enum{
	kCV_ALL = 0,
	kCV_CURSOR,
	kCV_LOW_CURSOR,
	kCV_SENTINEL	//ԕ
};

/*L[{[hiWCXeBbNj̏*/
enum{
	kKEY_NONE		= 0x0000,
	kKEY_LEFT		= 0x0001,
	kKEY_RIGHT		= 0x0002,
	kKEY_UP			= 0x0004,
	kKEY_DOWN		= 0x0008,
	kKEY_SPACE		= 0x0010,
	kKEY_Z			= 0x0020,
	kKEY_X			= 0x0040,
	kKEY_C			= 0x0080,
	kKEY_ENTER		= 0x0100,
	kKEY_TAB		= 0x0200,
	kKEY_SHIFT		= 0x0400,
	kKEY_DELBS		= 0x0800,
	kKEY_ERR		= 0x8000,
	kKEY_MOVE_MASK	= 0x000f,
	kKEY_BUTTON_MASK= 0xfff0,
	kKEY_ALL_MASK	= 0xffff
};

#define kKEY_YES	(kKEY_Z | kKEY_ENTER | kKEY_SPACE)
#define	kKEY_NO		(kKEY_X)

enum{
	kRESULT_ERR		= -1,
	kRESULT_NOP,
	kRESULT_OK,
	kRESULT_NG,
	kRESULT_CANCEL
};

/*f̎ނƂ*/
enum{
	kMDL_NONE = 0,		//fi󂫗̈j
	kMDL_FIELD_FLAT01,	//n
	kMDL_FIELD_ROCK01,	//
	kMDL_FIELD_SAND01,	//n
	kMDL_FIELD_NOT,		//ʍss\

	kMDL_PIECE_BS,		//m
	kMDL_PIECE_RS,		//Ԑm
	kMDL_PIECE_BA,		//|
	kMDL_PIECE_RA,		//ԋ|
	kMDL_PIECE_BT,		//Rm
	kMDL_PIECE_RT,		//ԋRm
	kMDL_PIECE_BC,		//
	kMDL_PIECE_RC,		//Ԃ

	kMDL_SYS_RANGE,		//I͈
	kMDL_SYS_CURSOR,	//J[\
	kMDL_SYS_BG,		//wi
	kMDL_SYS_MOVED,		//ړς݊
	kNUM_OF_MODELTYPE	//f̎
};

/*J[\ȂǃVXepIuWFNg̔wԍ*/
enum{
	kOBJ_SYS_CURSOR =0,
	kOBJ_SYS_BG,
	kNUM_OF_SYSOBJECT	//ԕ
};

/*IuWFNg̐Ƃ*/
enum{
	kLD_STANDBY = 0,	//i󂫗̈j
	kLD_BORN,			//
	kLD_LIVING,			//Ă܂
	kLD_FIGHT,			//Ă܂
	kLD_CRASH,			//ԂƂł܂
	kLD_DEAD,			//łł܂
	kLD_SENTINEL		//ԕ
};

/*LN^̃Xe[^X*/
enum{
	kSTATUS_NOP			= 0x00000000,

	kSTATUS_PLAYER		= 0x00000000,
	kSTATUS_CPU			= 0x00000001,
	kSTATUS_SIDE_MASK	= 0x0000000f,	// }XN

	kSTATUS_YET_ACTION	= 0x00000000,	// s	
	kSTATUS_END_ACTION	= 0x00000010,	// sς
	kSTATUS_ACTION_MASK = 0x000000f0,
};

#define	kSTATUS_MOVED_MASK		( kSTATUS_SIDE_MASK | kSTATUS_ACTION_MASK)
#define	kSTATUS_NOMOVE_PLAYER	( kSTATUS_PLAYER | kSTATUS_YET_ACTION)
#define	kSTATUS_MOVED_PLAYER	( kSTATUS_PLAYER | kSTATUS_END_ACTION)
#define	kSTATUS_NOMOVE_CPU		( kSTATUS_CPU | kSTATUS_YET_ACTION)
#define	kSTATUS_MOVED_CPU		( kSTATUS_CPU | kSTATUS_END_ACTION)

/*n`̂߂̒萔*/
enum{
	kM_NOT = 0,		/*ړs\*/
	kM_GRS,			/*n*/
	kM_SND,			/*n*/
	kM_RCK,			/**/
	kM_SENTINEL
};

//̎
enum{
	kTYPE_CASTLE = 0,
	kTYPE_SOLDER,
	kTYPE_ARCHER,
	kTYPE_TROOPER,
	kTYPE_SENTINEL
};

//̕iォ玞vɁj
enum{
	kDIR_UP = 0,
	kDIR_RIGHT,
	kDIR_DOWN,
	kDIR_LEFT,
	kDIR_SENTINEL
};

//Q[̏Ԃ\
enum{
	kMODE_GAME_STARTUP = 0,	//Q[
	kMODE_PLAYER_TURN,
	kMODE_SEL_PIECE,		//ړLI
	kMODE_SEL_DIST,			//LړʒuI
	kMODE_MOVING,			//L̈ړ
	kMODE_MOVED,			//ړセ̂܂܏I邩I
	kMODE_SEL_RIVAL,		//킹鑊I
	kMODE_VS_RIVAL,			//GLƐ키

	kMODE_CPU_TURN,
	kMODE_CPU_THINK,		//CPU̎vl

	kMODE_END,				//Q[I
	kMODE_TERMINATE,		//Ỉ
	kMODE_SENTINEL			//[h̔ԕ
};

//ړ[h̓
enum{
	ksROUTE_SEARCH = 0,
	ksROUTE_MOVING,
	ksROUTE_GOAL
};

//GI̓
enum{
	ksRIVAL_SEARCH = 0,
	ksRIVAL_SELECT,
	ksRIVAL_QUERY
};

//퓬̓
enum{
	ksVS_START = 0,
	ksVS_FIGHTING,
	ksVS_END,
	ksVS_RESULT,
	ksVS_EXIT
};

//CPU̎vl[h
enum{
	ksCPU_SEL_PIECE = 0,
	ksCPU_SEL_DIST,
	ksCPU_MOVING,
	ksCPU_SEL_RIVAL,
	ksCPU_VS_RIVAL
};

//ǂ̃^[H
enum{
	kTURN_PLAYER = 0,
	kTURN_CPU,
	kTURN_SENTINEL
};

enum{
	kCO_CHARGE = 0,
	kCO_RETREAT,
};

//ꕔX^eBbNϐ̂Ƃp
enum{
	kINT_INIT = 0,
	kINT_WRITE,
	kINT_READ
};

//=============================================================================
//@\̂̒`
//=============================================================================
struct theObject{
	D3DXVECTOR3	objPos;		// IuWFNg̍WB
	float		Yaw;		// [
	float		Roll;		// [
	float		Pitch;		// sb`
	int			MdlType;	// IuWFNg̃f̎
};

struct theModels{
	LPD3DXMESH			objMesh;			// VXẽbVIuWFNg
	D3DMATERIAL9*		objMeshMaterials;	// bV̎(materials)
	LPDIRECT3DTEXTURE9*	objMeshTextures;	// bṼeNX`(texture)
	DWORD				objNumOfMaterials;	// bV̐
	};

struct thePiece{
	int	x;			//W
	int y;
	int	dir;		//ǂނHilj
	int	hitpoint;	//qbg|Cg
	int	movPow;		//ړ
	int	attack;		//U
	int	defense;	//h
	int	pieceType;	//̎
	int	status;		//
	int	course;		//j
	int	LDflags;	//p
	int	counter;	//JE^
};

//=============================================================================
//@֐vg^Cv
//=============================================================================
HRESULT	InitD3D( HWND );									/*D3DXƂ̏*/

HRESULT	SetupModels( LPDIRECT3DDEVICE9 );					/*fނ̃ZbgAbv*/
HRESULT LoadModelsFromXFile( const char * ,theModels *, LPDIRECT3DDEVICE9 );
VOID	CleanUpD3D( void );									/*fނ̌n*/

HRESULT	SetupFont( LPDIRECT3DDEVICE9 );						/*IuWFNg̐ݒ*/
VOID	SetupLights( LPDIRECT3DDEVICE9 );					/*Cg̃ZbgAbv*/
VOID	SetupWorldMatrix( LPDIRECT3DDEVICE9 );				/*`s̐ݒ*/

HRESULT	InitDirectInput(  HWND , HINSTANCE );				/*DirectInput̏*/
int		GetKeybordData();									/*L[͂̎󂯎*/
VOID	CleanUpDirectInput( void );							/*DirectInpuťn*/

VOID	FlashGameMode( void );								//Q[[hƊȈՃwv̕\
VOID	FlashStatus( int , int );							//̃Xe[^X̕\
VOID	FlashPiece( void );									//̈ʒuȂǂ\

VOID	FlashString( const char * );						//̕`
VOID	FlashInt( int );									//l̕`
VOID	FlashRange( void );									//I͈͏̕`

VOID	calcTextRect( RECT * , int , int );
VOID	dispText( RECT * , const char * );

VOID	Render( LPDIRECT3DDEVICE9 );						//`揈S
VOID	drawMe( LPDIRECT3DDEVICE9 , theObject * );			//w肳ꂽIuWFNg̕`

LRESULT WINAPI MsgProc( HWND , UINT , WPARAM , LPARAM );	//bZ[Wnh

/*\̂Ƃ*/
VOID	InitSitus( void );

VOID	SetupSysSitus( void );
VOID	SetupMapSitus( void );
VOID	SetupRangeSitus( void );						//ړ\͈͂Ȃǂ̕\̈߂
VOID	SetupPieceSitus( void );						//̎_ŕ\\ȋݒ肷

VOID	ZeroObject( theObject *);

VOID	SetupObjMatrix(LPDIRECT3DDEVICE9 , theObject *);

/*Q[̃C*/
VOID	GameBody( HWND );
VOID	pieceNumWindow( int * , int * , int );			//ԍ󂯎邽߂̃gbN
int		checkPieceAlive( void );						//Q[̏I

VOID	InitGame( void );								//Q[̏
VOID	clearPieceFlags( int );
int		pieceMoveCheck( int );							//ĂȂ邩̃`FbN
VOID	pieceRecovering( int );							//̎͂ł̋̉
int		searchCastle( int );							//T

int		modeSelectPiece( int * );						//I
int		checkFeet( int , int);							//w肵ʒuɋH

int		modeSelectDist( thePiece *);					//̈ړ̑I

int		modeMoving( thePiece *);						//̈ړ
VOID	searchRoute( void );
VOID	checkRoute( int , int );
int		routeMoving( thePiece *);						//X^bNɏ]Ĉړ

int		modeSelectRival(const thePiece *, int *, int);	//퓬̑I

int		modeVSRival( thePiece * , thePiece * );			//ۂ̐퓬
int		calcAttackPoint( int  , int  , int  , int );
int		groundEffect( int );

int		modeCPUTurn( void );							//CPU̎
VOID	cpuSelectDistPos( thePiece * , int * , int *);	//CPUڕWʒu
VOID	cpuThinkAdvantage( thePiece * , int [][kMAP_MAX_WIDTH] );

VOID	setupPieces( void );							//̏
VOID	pieceRegain( thePiece * );						//̔\͒l̏

int		moveCursor( int );								//J[\̈ړ

VOID	CleanupMap( int [][kMAP_MAX_WIDTH] , int );		//ړ\͈͗pz̃NA
VOID	CopyMap( int [][kMAP_MAX_WIDTH] , int [][kMAP_MAX_WIDTH] );

VOID	LookupMovableRange( int , int ,const thePiece * , BOOL );		//ړ\͈͂̌
VOID	excludePiece( BOOL , int );
VOID	checkRange( int  , int  , int , int ,int [][kMAP_MAX_WIDTH]);
VOID	checkStep( int , int  , int , int ,int [][kMAP_MAX_WIDTH]);


/*}bv\֌W֗̕֐*/
VOID	CalcMapDimensions( RECT * );


#endif	/*__SAMPLE405__*/